c ------ Subroutine P_VECTOR -------------------------------------------
c Set the coefficient matrix P at collocation points for given sigma
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      subroutine pvector
#include "common.ins"
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /vector/ pvec(0:jx,1:nequ,0:nx,1:nvar,0:npar),
     |                rvec(0:jx,1:nequ,0:nx,1:nvar,2)
      common /params/ con(0:ncon),par(npar),dpar(npar,2),ipar(npar,2),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      character*8 conname,parname,varname
      character*80 problem
#ifdef CRAY
      complex pvec,rvec,uimag,zero
#else
      complex*16 pvec,rvec,uimag,zero
#endif
c **********************************************************************
#include "complex.ins"
c **********************************************************************
      zro=0
      one=1
      uimag=cmplx(zro,one)
      zero=cmplx(zro,zro)

c reset coefficient matrices to zero

      do 1 j=0,jx
        do 1 i=1,nequ
           do 1 n=0,nx
              do 1 l=1,nvar
                 pvec(j,i,n,l,0)=zero
1     continue

c set coefficient matrix at collocation points for given parameters

      ideriv=0
      do 2 j=0,jx

c **********************************************************************
#include "vector.ins"
c **********************************************************************

2     continue
      return
      end
