C **********************************************************************
C
C  INTEGER FUNCTION IZAMAX
C
C **********************************************************************
      INTEGER FUNCTION IZAMAX(N,ZX,INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, 3/11/78.
C

c Perform 64-bit arithmetic
      implicit double precision (a-h,o-z)






      complex*16 ZX(N)
      complex*16 ZDUM
C ----------------------------------------------------------------------
C
C  THE FOLLOWING STATEMENT FUNCTION WAS ADDED TO THIS SUBROUTINE ON
C  NOVEMBER 15, 1988  BECAUSE THE IBM FORTRAN LIBRARY DOESN'T HAVE IT.
C
C ----------------------------------------------------------------------
      DCABS1(ZDUM) = DABS(DREAL(ZDUM)) + DABS(DIMAG(ZDUM))
C
      IZAMAX = 1
      IF(N.LE.1)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENTS NOT EQUAL TO 1
C
      IX = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      SMAX = DCABS1(ZX(IX))
      IX = IX + INCX
      DO 10 I = 2,N
         IF(DCABS1(ZX(IX)).LE.SMAX) GO TO 5
         IZAMAX = IX
         SMAX = DCABS1(ZX(IX))
    5    IX = IX + INCX
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENTS EQUAL TO 1
C
   20 SMAX = DCABS1(ZX(1))
      DO 30 I = 2,N
         IF(DCABS1(ZX(I)).LE.SMAX) GO TO 30
         IZAMAX = I
         SMAX = DCABS1(ZX(I))
   30 CONTINUE
      RETURN
      END
